"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GitClientLive = exports.GitClient = void 0;
const effect_1 = require("effect");
const Command = __importStar(require("@effect/platform/Command"));
const CommandExecutor = __importStar(require("@effect/platform/CommandExecutor"));
const types_1 = require("./types");
exports.GitClient = effect_1.Context.Tag();
const runGitCommand = (commandExecutor) => (cmd) => (0, effect_1.pipe)(cmd, commandExecutor.start, effect_1.Effect.flatMap((process) => effect_1.Effect.all({
    stdout: toString(process.stdout),
    stderr: toString(process.stderr),
    exitCode: process.exitCode,
})), effect_1.Effect.flatMap(({ stderr, exitCode, stdout }) => exitCode === 0
    ? effect_1.Effect.succeed(stdout)
    : effect_1.Effect.fail((0, types_1.GitExecError)({
        message: `Git command failed with: [${stderr.trimEnd()}]`,
    }))), effect_1.Effect.catchTag('SystemError', (e) => effect_1.Effect.fail((0, types_1.GitExecError)({
    message: e.reason === 'NotFound'
        ? "Failed executing `git` command because `git` was not found. Please install `git` and make sure it's on your `$PATH`."
        : `Unexpected error during git execution: [${e.reason} ${e.message}]`,
}))), effect_1.Effect.catchTag('BadArgument', (e) => effect_1.Effect.fail((0, types_1.GitExecError)({
    message: `Unexpected error during git execution: [${e.message}]`,
}))), effect_1.Effect.scoped);
const listBranches = (commandExecutor) => () => (0, effect_1.pipe)(Command.make('git', 'branch'), runGitCommand(commandExecutor), effect_1.Effect.map((stdout) => effect_1.Chunk.fromIterable(stdout
    .trim()
    .split('\n')
    .map((x) => x.trim())
    .map((x) => x.replace(/^\*\s+/, '')))), effect_1.Effect.scoped);
const createGitBranchFrom = (commandExecutor) => (baseBranch) => (branchName, reset) => (0, effect_1.pipe)(Command.make('git', 'checkout', reset ? '-B' : '-b', branchName, baseBranch), runGitCommand(commandExecutor), effect_1.Effect.flatMap(() => effect_1.Effect.unit), effect_1.Effect.scoped);
const createGitBranch = (commandExecutor) => (branchName, reset) => (0, effect_1.pipe)(Command.make('git', 'checkout', reset ? '-B' : '-b', branchName), runGitCommand(commandExecutor), effect_1.Effect.flatMap(() => effect_1.Effect.unit), effect_1.Effect.scoped);
const switchBranch = (commandExecutor) => (branchName) => (0, effect_1.pipe)(Command.make('git', 'checkout', branchName), runGitCommand(commandExecutor), effect_1.Effect.flatMap(() => effect_1.Effect.unit), effect_1.Effect.scoped);
exports.GitClientLive = effect_1.Layer.effect(exports.GitClient, effect_1.Effect.map(CommandExecutor.CommandExecutor, (commandExecutor) => exports.GitClient.of({
    listBranches: listBranches(commandExecutor),
    createGitBranchFrom: createGitBranchFrom(commandExecutor),
    createGitBranch: createGitBranch(commandExecutor),
    switchBranch: switchBranch(commandExecutor),
})));
const toString = (stream) => {
    const decoder = new TextDecoder('utf-8');
    return effect_1.Effect.map(effect_1.Stream.run(stream, collectUint8Array), (bytes) => decoder.decode(bytes));
};
const collectUint8Array = effect_1.Sink.foldLeftChunks(new Uint8Array(), (bytes, chunk) => effect_1.Chunk.reduce(chunk, bytes, (acc, curr) => {
    const newArray = new Uint8Array(acc.length + curr.length);
    newArray.set(acc);
    newArray.set(curr, acc.length);
    return newArray;
}));
